/*
 * $Id: CreateAccount.java,v 1.3 2010/10/20 18:34:44 david Exp $
 * $Log: CreateAccount.java,v $
 * Revision 1.3  2010/10/20 18:34:44  david
 * *** empty log message ***
 *
 * Revision 1.2  2010/10/18 18:45:04  david
 * Fixed a few comments.
 *
 * Revision 1.1  2010/10/18 18:40:20  david
 * *** empty log message ***
 *
 * 
 */
package bank.textui.bank;

import static pt.utl.ist.po.ui.UserInteraction.IO;

import java.io.IOException;

import pt.utl.ist.po.ui.Command;
import pt.utl.ist.po.ui.InvalidOperation;
import bank.Bank;
import bank.BankAccount;

/**
 * Class for representing account creation.
 */
public class CreateAccount extends Command<Bank> {
	/**
	 * @param bank
	 *            the target bank
	 */
	public CreateAccount(Bank bank) {
		super(false, MenuEntry.CREATE_ACCOUNT, bank);
	}

	/**
	 * @throws InvalidOperation
	 */
	@Override
	public final void execute() throws InvalidOperation {
		try {
			double amount = IO.readFloat(Message.requestInitialBalance());
			BankAccount account = _receiver.createAccount(amount);
			IO.println(Message.accountCreated(account.getId()));
		} catch (IOException ioe) {
			throw new InvalidOperation(Message.errorCreatingAccount(ioe
					.toString()));
		}
	}
}