/*
 * $Id: CreateClient.java,v 1.3 2010/10/20 18:34:44 david Exp $
 * $Log: CreateClient.java,v $
 * Revision 1.3  2010/10/20 18:34:44  david
 * *** empty log message ***
 *
 * Revision 1.2  2010/10/18 18:45:04  david
 * Fixed a few comments.
 *
 * Revision 1.1  2010/10/18 18:40:20  david
 * *** empty log message ***
 *
 * 
 */
package bank.textui.bank;

import static pt.utl.ist.po.ui.UserInteraction.IO;

import java.io.IOException;

import pt.utl.ist.po.ui.Command;
import pt.utl.ist.po.ui.InvalidOperation;
import bank.Bank;
import bank.Client;

/**
 * Command for creating a new client.
 */
public class CreateClient extends Command<Bank> {
	/**
	 * @param bank
	 *            the bank for the new client.
	 */
	public CreateClient(Bank bank) {
		super(false, MenuEntry.CREATE_CLIENT, bank);
	}

	/**
	 * Request name and id (integer), then create the client.
	 * 
	 * @throws InvalidOperation
	 *             report possible IO exception in special message.
	 */
	@Override
	public final void execute() throws InvalidOperation {
		try {
			String name = IO.readString(Message.requestClientName());
			int id = IO.readInteger(Message.requestClientId());
			Client client = _receiver.createClient(name, id);
			IO.println(Message.createdClient(client.getId()));
		} catch (IOException ioe) {
			throw new InvalidOperation(Message.errorCreatingClient(ioe.toString()));
		}
	}
}