/*
 * $Id: OpenAccountMenu.java,v 1.2 2010/10/20 18:34:44 david Exp $
 * $Log: OpenAccountMenu.java,v $
 * Revision 1.2  2010/10/20 18:34:44  david
 * *** empty log message ***
 *
 * Revision 1.1  2010/10/18 18:40:20  david
 * *** empty log message ***
 *
 * 
 */
package bank.textui.bank;

import static pt.utl.ist.po.ui.UserInteraction.IO;

import java.io.IOException;

import pt.utl.ist.po.ui.Command;
import pt.utl.ist.po.ui.InvalidOperation;
import bank.Bank;
import bank.BankAccount;

/**
 * Command for opening a specific account's menu.
 */
public class OpenAccountMenu extends Command<Bank> {
	/**
	 * @param bank
	 *            the target bank
	 */
	public OpenAccountMenu(Bank bank) {
		super(false, MenuEntry.ACCOUNT_MENU, bank);
	}

	/**
	 * @throws InvalidOperation
	 */
	@Override
	public final void execute() throws InvalidOperation {
		try {
			int id = IO.readInteger(Message.requestAccountId());
			BankAccount account = _receiver.getAccount(id);

			if (account == null)
				IO.println(Message.errorSelectingAccount(id));
			else
				bank.textui.bankaccount.MenuBuilder.menuFor(account, _receiver);
		} catch (IOException ioe) {
			throw new InvalidOperation(Message.errorShowingAccount(ioe
					.toString()));
		}
	}
}