/*
 * $Id: OpenClientMenu.java,v 1.3 2010/10/20 18:34:44 david Exp $
 * $Log: OpenClientMenu.java,v $
 * Revision 1.3  2010/10/20 18:34:44  david
 * *** empty log message ***
 *
 * Revision 1.2  2010/10/18 18:45:04  david
 * Fixed a few comments.
 *
 * Revision 1.1  2010/10/18 18:40:20  david
 * *** empty log message ***
 *
 * 
 */
package bank.textui.bank;

import static pt.utl.ist.po.ui.UserInteraction.IO;

import java.io.IOException;

import pt.utl.ist.po.ui.Command;
import pt.utl.ist.po.ui.InvalidOperation;
import bank.Bank;
import bank.Client;

/**
 * Class for opening a client's menu.
 */
public class OpenClientMenu extends Command<Bank> {
	/**
	 * @param bank
	 *            the bank executing the command.
	 */
	public OpenClientMenu(Bank bank) {
		super(false, MenuEntry.CLIENT_MENU, bank);
	}

	/**
	 * Request client id (integer), then open its menu.
	 * 
	 * @throws InvalidOperation
	 */
	@Override
	public final void execute() throws InvalidOperation {
		try {
			int id = IO.readInteger(Message.requestClientId());
			Client client = _receiver.getClient(id);

			if (client == null)
				IO.println(Message.noSuchClient(id));
			else
				bank.textui.client.MenuBuilder.menuFor(client);
		} catch (IOException ioe) {
			throw new InvalidOperation(Message.errorShowingClient(ioe.toString()));
		}
	}
}