/*
 * $Id: Deposit.java,v 1.2 2010/10/20 18:34:44 david Exp $
 * $Log: Deposit.java,v $
 * Revision 1.2  2010/10/20 18:34:44  david
 * *** empty log message ***
 *
 * Revision 1.1  2010/10/18 18:40:20  david
 * *** empty log message ***
 *
 * 
 */
package bank.textui.bankaccount;

import static pt.utl.ist.po.ui.UserInteraction.IO;

import java.io.IOException;

import pt.utl.ist.po.ui.Command;
import pt.utl.ist.po.ui.InvalidOperation;
import bank.BankAccount;
import bank.InvalidDepositException;
import bank.NegativeAmountException;

/**
 * Class Deposit represents commands for making deposits.
 */
public class Deposit extends Command<BankAccount> {

	/**
	 * @param account
	 *            the target account.
	 */
	public Deposit(BankAccount account) {
		super(false, MenuEntry.DEPOSIT, account);
	}

	/**
	 * @throws InvalidOperation
	 */
	@Override
	public final void execute() throws InvalidOperation {
		try {
			float amount = IO.readFloat(Message.requestAmount());
			_receiver.deposit(amount);
		} catch (IOException ioe) {
			throw new InvalidOperation(ioe.toString());
		} catch (InvalidDepositException e) {
			throw new InvalidOperation(Message.invalidDeposit());
		} catch (NegativeAmountException e) {
			throw new InvalidOperation(Message.invalidNegativeAmountDeposit(e.getAmount()));
		}
	}
}