/*
 * $Id: MenuBuilder.java,v 1.2 2010/10/20 18:34:44 david Exp $
 * $Log: MenuBuilder.java,v $
 * Revision 1.2  2010/10/20 18:34:44  david
 * *** empty log message ***
 *
 * Revision 1.1  2010/10/18 18:40:20  david
 * *** empty log message ***
 *
 * 
 */
package bank.textui.bankaccount;

import pt.utl.ist.po.ui.Command;
import pt.utl.ist.po.ui.Menu;
import bank.Bank;
import bank.BankAccount;

/**
 * Menu builder for bank accounts.
 */
public abstract class MenuBuilder {

	/**
	 * @param bankAccount 
	 * 
	 * @param bank
	 *            the bank this account belongs to.
	 */
	public static void menuFor(BankAccount bankAccount, Bank bank) {
		Menu menu = new Menu(MenuEntry.TITLE, new Command<?>[] {
				new Deposit(bankAccount),
				new Withdraw(bankAccount),
				new ShowBalance(bankAccount, false),
				new ShowBalance(bankAccount, true),
				new ShowAccountClients(bankAccount),
				new CreateSavingsAccount(bankAccount),
				new ShowAllSavingsAccounts(bankAccount),
				new ShowSpecificSavingsAccount(bankAccount),
				new RemoveAccount(bankAccount, bank) });
		menu.open();
	}

}
