/*
 * $Id: RemoveAccount.java,v 1.3 2010/10/20 18:34:44 david Exp $
 * $Log: RemoveAccount.java,v $
 * Revision 1.3  2010/10/20 18:34:44  david
 * *** empty log message ***
 *
 * Revision 1.2  2010/10/18 18:45:04  david
 * Fixed a few comments.
 *
 * 
 */
package bank.textui.bankaccount;

import static pt.utl.ist.po.ui.UserInteraction.IO;
import pt.utl.ist.po.ui.Command;
import pt.utl.ist.po.ui.InvalidOperation;
import bank.Bank;
import bank.BankAccount;
import bank.InvalidRemovalException;

/**
 * This class represents the removal of a bank account. If successful, the
 * control should return to the previous menu.
 */
public class RemoveAccount extends Command<BankAccount> {
	/** The bank owning the account. */
	Bank _bank;

	/**
	 * @param account
	 *            the target account.
	 * @param bank
	 *            the bank the account belongs to.
	 */
	public RemoveAccount(BankAccount account, Bank bank) {
		super(true, MenuEntry.REMOVE_ACCOUNT, account);
		_bank = bank;
	}

	/**
	 * @throws InvalidOperation
	 */
	@Override
	public final void execute() throws InvalidOperation {
		try {
			_bank.removeAccount(_receiver);
		} catch (InvalidRemovalException ire) {
			IO.println(bank.textui.bank.Message.errorRemovingAccount(ire.getAccount(), ire.getAmount()));
		}
	}
}