/*
 * $Id: ShowAllSavingsAccounts.java,v 1.2 2010/10/20 18:34:44 david Exp $
 * $Log: ShowAllSavingsAccounts.java,v $
 * Revision 1.2  2010/10/20 18:34:44  david
 * *** empty log message ***
 *
 * Revision 1.1  2010/10/18 18:40:20  david
 * *** empty log message ***
 *
 * 
 */
package bank.textui.bankaccount;

import static pt.utl.ist.po.ui.UserInteraction.IO;

import java.util.List;

import pt.utl.ist.po.ui.Command;
import bank.BankAccount;
import bank.SavingsAccount;

/**
 * This class represents a command for showing all the savings accounts.
 */
public class ShowAllSavingsAccounts extends Command<BankAccount> {

	/**
	 * @param account
	 *            the target account.
	 */
	public ShowAllSavingsAccounts(BankAccount account) {
		super(false, MenuEntry.SHOW_ALL_SAVINGS_ACCOUNTS, account);
	}

	/**
	 * Executes the command.
	 */
	@Override
	public final void execute() {
		List<SavingsAccount> accounts = _receiver.getSavingsAccounts();
		if (accounts != null)
			IO.println(accounts.toString());
		else
			IO.println(Message.errorShowingSavingsAccounts());
	}
}