/*
 * $Id: ShowBalance.java,v 1.3 2010/10/20 18:34:44 david Exp $
 * $Log: ShowBalance.java,v $
 * Revision 1.3  2010/10/20 18:34:44  david
 * *** empty log message ***
 *
 * Revision 1.2  2010/10/18 18:45:04  david
 * Fixed a few comments.
 *
 * Revision 1.1  2010/10/18 18:40:20  david
 * *** empty log message ***
 *
 * 
 */
package bank.textui.bankaccount;

import static pt.utl.ist.po.ui.UserInteraction.IO;
import pt.utl.ist.po.ui.Command;
import bank.BankAccount;

/**
 * Class representing a command for showing the balance of an account.
 */
public class ShowBalance extends Command<BankAccount> {

	/** If true show the total balance. */
	private boolean _showTotalBalance = false;

	/**
	 * @param account
	 *            the target bank account.
	 * @param showTotalBalance
	 *            if true, show the total balance; otherwise, show only the
	 *            demand account's balance.
	 */
	public ShowBalance(BankAccount account, boolean showTotalBalance) {
		super(false, (showTotalBalance ? Message.titleTotalBalance() : Message
				.titleDemandBalance()), account);
		_showTotalBalance = showTotalBalance;
	}

	/**
	 * Executes the command.
	 */
	@Override
	public final void execute() {
		IO.println(_showTotalBalance ? Message.showTotalBalance(_receiver
				.getBalance()) : Message.showDemandBalance(_receiver
				.getDemandAccountBalance()));
	}
}