/*
 * $Id: ShowSpecificSavingsAccount.java,v 1.2 2010/10/20 18:34:44 david Exp $
 * $Log: ShowSpecificSavingsAccount.java,v $
 * Revision 1.2  2010/10/20 18:34:44  david
 * *** empty log message ***
 *
 * Revision 1.1  2010/10/18 18:40:20  david
 * *** empty log message ***
 *
 * 
 */
package bank.textui.bankaccount;

import static pt.utl.ist.po.ui.UserInteraction.IO;

import java.io.IOException;
import java.util.List;

import pt.utl.ist.po.ui.Command;
import pt.utl.ist.po.ui.InvalidOperation;
import bank.BankAccount;
import bank.SavingsAccount;

/**
 * Class for showing a specific savings account.
 */
public class ShowSpecificSavingsAccount extends Command<BankAccount> {

	/**
	 * @param account
	 */
	public ShowSpecificSavingsAccount(BankAccount account) {
		super(false, MenuEntry.SHOW_SAVINGS_ACCOUNT, account);
	}

	/**
	 * @throws InvalidOperation
	 */
	@Override
	public final void execute() throws InvalidOperation {
		try {
			int id = IO.readInteger(Message.requestSavingsAccountId());
			List<SavingsAccount> accounts = _receiver.getSavingsAccounts();
			if (accounts != null) {
				for (SavingsAccount account : accounts) {
					if (account.getId() == id) {
						bank.textui.savingsaccount.MenuBuilder.menuFor(account);
						return;
					}
				}
			}
			IO.println(Message.errorShowingSavingsAccount());
		} catch (IOException ioe) {
			throw new InvalidOperation(ioe.toString());
		}
	}
}