/*
 * $Id: Withdraw.java,v 1.2 2010/10/20 18:34:44 david Exp $
 * $Log: Withdraw.java,v $
 * Revision 1.2  2010/10/20 18:34:44  david
 * *** empty log message ***
 *
 * Revision 1.1  2010/10/18 18:40:20  david
 * *** empty log message ***
 *
 * 
 */
package bank.textui.bankaccount;

import static pt.utl.ist.po.ui.UserInteraction.IO;

import java.io.IOException;

import pt.utl.ist.po.ui.Command;
import pt.utl.ist.po.ui.InvalidOperation;
import bank.BalanceTooLowException;
import bank.BankAccount;
import bank.InvalidWithdrawalException;
import bank.NegativeAmountException;

/**
 * This class represents a withdrawal command.
 */
public class Withdraw extends Command<BankAccount> {

	/**
	 * @param account
	 *            the target account
	 */
	public Withdraw(BankAccount account) {
		super(false, MenuEntry.WITHDRAW, account);
	}

	/**
	 * @throws InvalidOperation
	 */
	@Override
	public final void execute() throws InvalidOperation {
		try {
			float amount = IO.readFloat(Message.requestAmount());
			_receiver.withdraw(amount);
		} catch (IOException ioe) {
			throw new InvalidOperation(ioe.toString());
		} catch (InvalidWithdrawalException e) {
			throw new InvalidOperation(e.getMessage());
		} catch (NegativeAmountException e) {
			throw new InvalidOperation(Message.invalidNegativeAmountWithdrawal(e.getAmount()));
		} catch (BalanceTooLowException e) {
			throw new InvalidOperation(Message.notEnoughBalance(e.getBalance(), e.getAmount()));
		}
	}
}